/*
 *	spTopLevel_Mac.h
 */

#ifndef __SPTOPLEVEL_MAC_H
#define __SPTOPLEVEL_MAC_H

#if defined(MACOSX)
#include <Carbon/Carbon.h>
#else
#include <MacTypes.h>
#include <Menus.h>
#include <Quickdraw.h>
#include <QDOffscreen.h>
#if TARGET_API_MAC_CARBON
#include <CarbonEvents.h>
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined(MACOSX)
#define SP_MAC_USER_EVENT_BY_CARBON_EVENT
#else
#undef SP_MAC_USER_EVENT_BY_CARBON_EVENT
#endif
    
#define SP_USE_DEFAULT_CALLBACK_STRUCT
#if defined(SP_MAC_USER_EVENT_BY_CARBON_EVENT)
#undef SP_USE_DEFAULT_USER_EVENT
#else
#define SP_USE_DEFAULT_USER_EVENT
#endif
    
#define SP_MAC_DEFAULT_NUM_USER_EVENT 20
  
#define SP_DUMMY_GWORLD_WIDTH 5
#define SP_DUMMY_GWORLD_HEIGHT 5
    
typedef struct _spTopLevelArchPart {
    Handle menu_bar;
    MenuHandle apple_menu;
    MenuHandle file_menu;
    MenuHandle edit_menu;
    MenuHandle help_menu;
    MenuHandle window_menu;
    int num_help_menu;

    spBool message_loop_started;
#ifdef SP_MAC_USER_EVENT_BY_CARBON_EVENT
    EventQueueRef event_queue;
#else
    spUserEventDefault user_event;
#endif
#if defined(MACOSX)
    void *event_loop_event;
#endif
} spTopLevelArchPart;

#if defined(MACOS)
#pragma import on
#endif

extern spBool spIsExecFromOtherAppMac(void);
extern spBool spSetDummyGWorldMac(void);
extern spBool spGetOriginalGWorldMac(GWorldPtr *save_gwp, GDHandle *save_gdh);
extern long spGetSystemVersionMac(void);
extern long spGetAppearanceVersionMac(void);
extern long spGetCarbonVersionMac(void);
extern spBool spIsCarbonEventAvailableMac(void);
extern spBool spIsAquaMac(void);
extern int spGetPixelDepthMac(Boolean *is_color);
extern void spSetCursorMac(CursHandle cursor);
extern void spUnsetCursorMac(void);
extern short spSetMainResFileMac(void);
extern Handle spGetResourceMac(ResType type, short id);
extern Handle spGetNamedResourceMac(ResType type, ConstStr255Param name);

extern spBool spIsStartedMac(void);
extern spBool spIsInPThreadMac(void);
extern void spLockMainMutexMac(void);
extern void spUnlockMainMutexMac(void);
extern void spLockMainMutexForMainMac(void);
extern void spUnlockMainMutexForMainMac(void);
extern void spLockMainMutexForThreadMac(void);
extern void spUnlockMainMutexForThreadMac(void);
extern void spLockPortMutexMac(void);
extern void spUnlockPortMutexMac(void);
extern void spLockDrawMutexMac(void);
extern void spUnlockDrawMutexMac(void);
extern void spLockControlMutexMac(void);
extern void spUnlockControlMutexMac(void);
extern void spLockMenuMutexMac(void);
extern void spUnlockMenuMutexMac(void);
extern UInt32 spGetLastEventModifiersMac(void);
#if TARGET_API_MAC_CARBON
extern int spWaitNextEventCarbonMac(unsigned long sleep, EventRef *event);
#endif
extern int spWaitNextEventNonCarbonMac(unsigned long sleep, EventRecord *event);
extern int spDispatchEventMac(spTopLevel toplevel, unsigned long sleep);
extern int spDispatchEventEffectiveMac(spTopLevel toplevel);
extern GrafPtr spThreadEnterMac(GrafPtr new_port);
extern GrafPtr spThreadLeaveMac(GrafPtr new_port);
    
#if !TARGET_API_MAC_CARBON
extern int spProcessTimerEventMac(void);
#endif

#if defined(MACOS)
#pragma import off
#endif

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPTOPLEVEL_MAC_H */
