/*
 *	spComboBox_Win.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spMemory.h>

#include <sp/spListP.h>
#include <sp/spComboBoxP.h>

extern spTopLevel sp_toplevel;

static void spChangeComboBoxEditableWin(spComponent component, spBool editable)
{
    COMBOBOXINFO cbi;
    HWND hwndText;

    cbi.cbSize = sizeof(COMBOBOXINFO);
    if (SendMessage(SpPrimitiveArch(component).hwnd, CB_GETCOMBOBOXINFO, 0, (LPARAM)&cbi)
	&& cbi.hwndItem != NULL) {
	hwndText = cbi.hwndItem;
	SendMessage(hwndText, EM_SETREADONLY, (WPARAM)(BOOL)(editable == SP_FALSE ? TRUE : FALSE), 0);
    } else {
	spDebug(60, "spChangeComboBoxEditableWin", "CB_GETCOMBOBOXINFO failed\n");
    }

    return;
}

void spComboBoxCreateArch(spComponent component)
{
    /* create combo box */
    SpPrimitiveArch(component).hwnd =
	CreateWindowEx(WS_EX_CLIENTEDGE, "COMBOBOX", NULL,
		       ((SpComboBoxPart(component).select_only == SP_TRUE) ?
			CBS_DROPDOWNLIST : CBS_DROPDOWN)
		       | spGetVisibleStyleWin(component)
		       | WS_CHILD | WS_CLIPCHILDREN | WS_TABSTOP
		       | WS_VSCROLL | CBS_AUTOHSCROLL | CBS_DISABLENOSCROLL
		       | CBS_NOINTEGRALHEIGHT,
		       SpComponentPart(component).x, SpComponentPart(component).y,
		       SpComponentPart(component).current_width,
		       SpComboBoxPart(component).size,
		       SpParentPrimitiveArch(component).hwnd,
		       (HMENU)SpComponentPart(component).component_id,
		       SpTopLevelArch(sp_toplevel).hThisInst,
		       NULL);
    SendMessage(SpPrimitiveArch(component).hwnd, WM_SETFONT,
		(WPARAM)SpTopLevelArch(sp_toplevel).sys_font, MAKELPARAM(TRUE, 0));

    if (SpTextPart(component).editable == SP_FALSE) {
	spChangeComboBoxEditableWin(component, SP_FALSE);
    }
    
    return;
}

void spComboBoxSetParamsArch(spComponent component)
{
    if (SpTextPart(SpOldObject(component)).editable != SpTextPart(component).editable) {
	spChangeComboBoxEditableWin(component, SpTextPart(component).editable);
    }
    
    return;
}
