/*
 *	spProgressBar_Gtk.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spBase.h>
#include <sp/spMemory.h>

#include <sp/spProgressBarP.h>

void spProgressBarCreateArch(spComponent component)
{
#if GTK_CHECK_VERSION(3,0,0)
    SpPrimitiveArch(component).widget = gtk_progress_bar_new();
#else
    SpPrimitiveArch(component).adjustment =
	gtk_adjustment_new((gfloat)SpProgressBarPart(component).value,
			   (gfloat)SpProgressBarPart(component).minimum,
			   (gfloat)(SpProgressBarPart(component).maximum),
			   (gfloat)SpProgressBarPart(component).increment,
			   (gfloat)SpProgressBarPart(component).increment,
			   (gfloat)SpProgressBarPart(component).increment);
    
    SpPrimitiveArch(component).widget =
	gtk_progress_bar_new_with_adjustment(GTK_ADJUSTMENT(SpPrimitiveArch(component).adjustment));
#endif
    
    spPrimitiveContainerAddGtk(component);

    return;
}

void spProgressBarSetParamsArch(spComponent component)
{
    return;
}

void spProgressBarSetValueArch(spComponent component)
{
    spProgressBarIncrementArch(component, SpProgressBarPart(component).value);
    
    return;
}

void spProgressBarIncrementArch(spComponent component, int new_value)
{
#if GTK_CHECK_VERSION(3,0,0)
    gdouble range;
    gdouble fraction;

    range = (gfloat)(SpProgressBarPart(component).maximum - SpProgressBarPart(component).minimum);
    fraction = (gfloat)(new_value - SpProgressBarPart(component).minimum) / range;
    gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(SpPrimitiveArch(component).widget), fraction);
#else
    gtk_progress_set_value(GTK_PROGRESS(SpPrimitiveArch(component).widget),
			   (gfloat)new_value);
#endif
    
    return;
}
