/*
 *	spProgressBar_Mac.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sp/spDefs.h>
#include <sp/spMemory.h>

#include <sp/spTopLevelP.h>
#include <sp/spProgressBarP.h>

void spProgressBarCreateArch(spComponent component)
{
    if (spGetAppearanceVersionMac() >= 0x00000101) {
	spComponent window;
	Rect rect;
    
	spSetComponentRectMac(component,
			      SpComponentPart(component).current_width,
			      SpComponentPart(component).current_height);
	rect = SpPrimitiveArch(component).rect;
	
	window = SpGetWindow(component);
    
	SpPrimitiveArch(component).control =
	    NewControl(SpPrimitiveArch(window).window,
		       &rect, "\p", spIsVisibleMac(component),
		       0, 0, 0, kControlProgressBarProc, 0);
	
	spSetReferenceMac(component);
	spSetNeedUpdateMac(component);
	
	spProgressBarSetParamsArch(component);
    } else {
	spProgressBarCreateDefault(component);
    }
    
    return;
}

void spProgressBarSetParamsArch(spComponent component)
{
    if (SpPrimitiveArch(component).control != nil) {
	SetControlMinimum(SpPrimitiveArch(component).control, SpProgressBarPart(component).minimum);
	SetControlMaximum(SpPrimitiveArch(component).control, SpProgressBarPart(component).maximum);
	SetControlValue(SpPrimitiveArch(component).control, SpProgressBarPart(component).value);
    } else {
    }
    
    return;
}

void spProgressBarSetValueArch(spComponent component)
{
    if (SpPrimitiveArch(component).control != nil) {
	spProgressBarIncrementArch(component, SpProgressBarPart(component).value);
    } else {
	spProgressBarSetValueDefault(component);
    }
    
    return;
}

void spProgressBarIncrementArch(spComponent component, int new_value)
{
    if (SpPrimitiveArch(component).control != nil) {
	spLockDrawMutexMac();
	SetControlValue(SpPrimitiveArch(component).control, new_value);
	spUnlockDrawMutexMac();
    } else {
	spProgressBarIncrementDefault(component, new_value);
    }
    
    return;
}
